--- /dev/null	Sat Mar 17 17:03:38 2007
+++ sys/compat/linux/linux_aio.h	Sat Mar 17 17:03:39 2007
@@ -0,0 +1,98 @@
+/*-
+ * Copyright (c) 2006 Li, Xiao <intron@intron.ac>.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $FreeBSD: src/sys/compat/linux/linux_aio.h,v 1.1 2006/10/15 14:22:13 netchild Exp $
+ */
+
+/*
+ * Linux Kernel Implementation of Asynchronous I/O
+ */
+
+#ifndef	_LINUX_AIO_H_
+#define	_LINUX_AIO_H_
+
+typedef unsigned long linux_aio_context_t;
+
+enum {
+	LINUX_IOCB_CMD_PREAD = 0,
+	LINUX_IOCB_CMD_PWRITE = 1,
+	LINUX_IOCB_CMD_FSYNC = 2,
+	LINUX_IOCB_CMD_FDSYNC = 3,
+#if 0
+	LINUX_IOCB_CMD_PREADX = 4,
+	LINUX_IOCB_CMD_POLL = 5,
+#endif
+	LINUX_IOCB_CMD_NOOP = 6,
+};
+
+struct linux_io_event {
+	uint64_t	data;
+	uint64_t	obj;
+	int64_t		res;
+	int64_t		res2;
+};
+
+#if _BYTE_ORDER == _LITTLE_ENDIAN
+#define LINUX_AIO_PADDED(x,y)	x,y
+#elif _BYTE_ORDER == _BIG_ENDIAN
+#define LINUX_AIO_PADDED(x,y)	y,x
+#else
+#error Unidentified byte order !!!
+#endif
+
+struct linux_iocb {
+	uint64_t	aio_data;
+	uint32_t	LINUX_AIO_PADDED(aio_key, aio_reserved1);
+
+	uint16_t	aio_lio_opcode;
+	int16_t		aio_reqprio;
+	uint32_t	aio_fildes;
+
+	uint64_t	aio_buf;
+	uint64_t	aio_nbytes;
+	int64_t		aio_offset;
+
+	uint64_t	aio_reserved2;	/* TODO: use this for a (struct sigevent *) */
+	uint64_t	aio_reserved3;
+
+};
+
+/* User space context information structure */
+struct linux_aio_ring {
+	l_uint	ring_id;
+	l_uint	ring_nr;
+	l_uint	ring_head;
+	l_uint	ring_tail;
+#define LINUX_AIO_RING_MAGIC			0xa10a10a1
+	l_uint	ring_magic;
+#define LINUX_AIO_RING_COMPAT_FEATURES		1
+	l_uint	ring_compat_features;
+#define LINUX_AIO_RING_INCOMPAT_FEATURES	0
+	l_uint	ring_incompat_features;
+	l_uint	ring_header_length; /* Size of this structure */
+
+	struct linux_io_event	ring_io_events[0];
+};
+
+#endif /* !_LINUX_AIO_H_ */
--- sys/compat/linux/linux_emul.c.orig
+++ sys/compat/linux/linux_emul.c
@@ -56,7 +56,7 @@
 #endif
 
 struct sx emul_shared_lock;
-struct sx emul_lock;
+struct mtx emul_lock;
 
 /* this returns locked reference to the emuldata entry (if found) */
 struct linux_emuldata *
--- sys/compat/linux/linux_emul.h.orig
+++ sys/compat/linux/linux_emul.h
@@ -57,8 +57,8 @@
 
 struct linux_emuldata *em_find(struct proc *, int locked);
 
-#define EMUL_LOCK(l)	sx_xlock(l)
-#define EMUL_UNLOCK(l)	sx_xunlock(l)
+#define EMUL_LOCK(l)	mtx_lock(l)
+#define EMUL_UNLOCK(l)	mtx_unlock(l)
 
 #define EMUL_SHARED_RLOCK(l) sx_slock(l)
 #define EMUL_SHARED_RUNLOCK(l) sx_sunlock(l)
@@ -75,6 +75,6 @@
 void	linux_proc_exec(void *, struct proc *, struct image_params *);
 
 extern struct sx emul_shared_lock;
-extern struct sx emul_lock;
+extern struct mtx emul_lock;
 
 #endif	/* !_LINUX_EMUL_H_ */
--- sys/compat/linux/linux_file.c.orig
+++ sys/compat/linux/linux_file.c
@@ -43,6 +43,7 @@
 #include <sys/malloc.h>
 #include <sys/mount.h>
 #include <sys/mutex.h>
+#include <sys/namei.h>
 #include <sys/proc.h>
 #include <sys/stat.h>
 #include <sys/sx.h>
@@ -85,57 +86,51 @@
     return (error);
 }
 
-int
-linux_open(struct thread *td, struct linux_open_args *args)
+
+static int
+linux_common_open(struct thread *td, char *path, int l_flags, int mode, int openat)
 {
     struct proc *p = td->td_proc;
     struct file *fp;
     int fd;
-    char *path;
     int bsd_flags, error;
 
-    if (args->flags & LINUX_O_CREAT)
-	LCONVPATHCREAT(td, args->path, &path);
-    else
-	LCONVPATHEXIST(td, args->path, &path);
-
-#ifdef DEBUG
-	if (ldebug(open))
-		printf(ARGS(open, "%s, 0x%x, 0x%x"),
-		    path, args->flags, args->mode);
-#endif
     bsd_flags = 0;
-    if (args->flags & LINUX_O_RDONLY)
-	bsd_flags |= O_RDONLY;
-    if (args->flags & LINUX_O_WRONLY)
+    switch (l_flags & LINUX_O_ACCMODE) {
+    case LINUX_O_WRONLY:
 	bsd_flags |= O_WRONLY;
-    if (args->flags & LINUX_O_RDWR)
+	break;
+    case LINUX_O_RDWR:
 	bsd_flags |= O_RDWR;
-    if (args->flags & LINUX_O_NDELAY)
+	break;
+    default:
+	bsd_flags |= O_RDONLY;
+    }
+    if (l_flags & LINUX_O_NDELAY)
 	bsd_flags |= O_NONBLOCK;
-    if (args->flags & LINUX_O_APPEND)
+    if (l_flags & LINUX_O_APPEND)
 	bsd_flags |= O_APPEND;
-    if (args->flags & LINUX_O_SYNC)
+    if (l_flags & LINUX_O_SYNC)
 	bsd_flags |= O_FSYNC;
-    if (args->flags & LINUX_O_NONBLOCK)
+    if (l_flags & LINUX_O_NONBLOCK)
 	bsd_flags |= O_NONBLOCK;
-    if (args->flags & LINUX_FASYNC)
+    if (l_flags & LINUX_FASYNC)
 	bsd_flags |= O_ASYNC;
-    if (args->flags & LINUX_O_CREAT)
+    if (l_flags & LINUX_O_CREAT)
 	bsd_flags |= O_CREAT;
-    if (args->flags & LINUX_O_TRUNC)
+    if (l_flags & LINUX_O_TRUNC)
 	bsd_flags |= O_TRUNC;
-    if (args->flags & LINUX_O_EXCL)
+    if (l_flags & LINUX_O_EXCL)
 	bsd_flags |= O_EXCL;
-    if (args->flags & LINUX_O_NOCTTY)
+    if (l_flags & LINUX_O_NOCTTY)
 	bsd_flags |= O_NOCTTY;
-    if (args->flags & LINUX_O_DIRECT)
+    if (l_flags & LINUX_O_DIRECT)
 	bsd_flags |= O_DIRECT;
-    if (args->flags & LINUX_O_NOFOLLOW)
+    if (l_flags & LINUX_O_NOFOLLOW)
 	bsd_flags |= O_NOFOLLOW;
     /* XXX LINUX_O_NOATIME: unable to be easily implemented. */
 
-    error = kern_open(td, path, UIO_SYSSPACE, bsd_flags, args->mode);
+    error = kern_open(td, path, UIO_SYSSPACE, bsd_flags, mode);
     if (!error) {
 	    fd = td->td_retval[0];
 	    /*
@@ -158,7 +153,7 @@
 			    PROC_UNLOCK(p);
 			    sx_sunlock(&proctree_lock);
 		    }
-		    if (args->flags & LINUX_O_DIRECTORY) {
+		    if (l_flags & LINUX_O_DIRECTORY) {
 			    if (fp->f_type != DTYPE_VNODE ||
 				fp->f_vnode->v_type != VDIR) {
 				    error = ENOTDIR;
@@ -177,10 +172,121 @@
     if (ldebug(open))
 	    printf(LMSG("open returns error %d"), error);
 #endif
-    LFREEPATH(path);
+    if (!openat)
+	LFREEPATH(path);
     return error;
 }
 
+/*
+ * common code for linux *at set of syscalls
+ *
+ * works like this:
+ * if filename is absolute 
+ *    ignore dirfd
+ * else
+ *    if dirfd == AT_FDCWD 
+ *       return CWD/filename
+ *    else
+ *       return DIRFD/filename
+ */
+static int
+linux_at(struct thread *td, int dirfd, char *filename, char **newpath, char **freebuf)
+{
+   	struct file *fp;
+	int error = 0;
+	struct vnode *dvp;
+	struct filedesc *fdp = td->td_proc->p_fd;
+	char *fullpath = "unknown";
+	char *freepath = NULL;
+
+	/* don't do anything if the pathname is absolute */
+	if (*filename == '/') {
+	   	*newpath= filename;
+	   	return (0);
+	}
+
+	/* check for AT_FDWCD */
+	if (dirfd == LINUX_AT_FDCWD) {
+	   	FILEDESC_LOCK(fdp);
+		dvp = fdp->fd_cdir;
+	   	FILEDESC_UNLOCK(fdp);
+	} else {
+	   	error = fget(td, dirfd, &fp);
+		if (error)
+		   	return (error);
+		dvp = fp->f_vnode;
+		/* only a dir can be dfd */
+		if (dvp->v_type != VDIR) {
+		   	fdrop(fp, td);
+			return (ENOTDIR);
+		}
+		fdrop(fp, td);
+	}
+
+	error = vn_fullpath(td, dvp, &fullpath, &freepath);
+	if (!error) {
+	   	*newpath = malloc(strlen(fullpath) + strlen(filename) + 2, M_TEMP, M_WAITOK | M_ZERO);
+		*freebuf = freepath;
+		sprintf(*newpath, "%s/%s", fullpath, filename);
+	}
+
+	return (error);
+}
+
+int
+linux_openat(struct thread *td, struct linux_openat_args *args)
+{
+   	char *newpath, *oldpath, *freebuf = NULL, *path;
+	int error;
+
+	oldpath = malloc(MAXPATHLEN, M_TEMP, M_WAITOK);
+	error = copyinstr(args->filename, oldpath, MAXPATHLEN, NULL);
+
+#ifdef DEBUG
+	if (ldebug(openat))
+		printf(ARGS(openat, "%i, %s, 0x%x, 0x%x"), args->dfd,
+		    oldpath, args->flags, args->mode);
+#endif
+
+	error = linux_at(td, args->dfd, oldpath, &newpath, &freebuf);
+	if (error)
+	   	return (error);
+#ifdef DEBUG
+	printf(LMSG("newpath: %s"), newpath);
+#endif
+    	if (args->flags & LINUX_O_CREAT)
+		LCONVPATH_SEG(td, newpath, &path, 1, UIO_SYSSPACE);
+    	else
+		LCONVPATH_SEG(td, newpath, &path, 0, UIO_SYSSPACE);
+	if (freebuf)
+	   	free(freebuf, M_TEMP);
+	if (*oldpath != '/')
+   	   	free(newpath, M_TEMP);
+
+	error = linux_common_open(td, path, args->flags, args->mode, 1);
+	free(oldpath, M_TEMP);
+	return (error);
+}
+
+int
+linux_open(struct thread *td, struct linux_open_args *args)
+{
+    char *path;
+
+    if (args->flags & LINUX_O_CREAT)
+	LCONVPATHCREAT(td, args->path, &path);
+    else
+	LCONVPATHEXIST(td, args->path, &path);
+
+#ifdef DEBUG
+	if (ldebug(open))
+		printf(ARGS(open, "%s, 0x%x, 0x%x"),
+		    path, args->flags, args->mode);
+#endif
+
+    return linux_common_open(td, path, args->flags, args->mode, 0);
+}
+
 int
 linux_lseek(struct thread *td, struct linux_lseek_args *args)
 {
--- sys/compat/linux/linux_futex.c.orig
+++ sys/compat/linux/linux_futex.c
@@ -88,17 +88,15 @@
 static struct futex	*futex_get(void *, int);
 static void futex_put(struct futex *);
 static int futex_sleep(struct futex *, struct thread *, unsigned long);
-static int futex_wake(struct futex *, int, struct futex *);
-#ifdef __i386__
+static int futex_wake(struct futex *, int, struct futex *, int);
 static int futex_atomic_op(struct thread *td, int encoded_op, caddr_t uaddr);
-#endif 
+static int futex_orl(int oparg, caddr_t uaddr, int *oldval);
+static int futex_andl(int oparg, caddr_t uaddr, int *oldval);
+static int futex_xorl(int oparg, caddr_t uaddr, int *oldval);
 
 /* support.s */
 int futex_xchgl(int oparg, caddr_t uaddr, int *oldval);
 int futex_addl(int oparg, caddr_t uaddr, int *oldval);
-int futex_orl(int oparg, caddr_t uaddr, int *oldval);
-int futex_andnl(int oparg, caddr_t uaddr, int *oldval);
-int futex_xorl(int oparg, caddr_t uaddr, int *oldval);
 
 int
 linux_sys_futex(struct thread *td, struct linux_sys_futex_args *args)
@@ -111,10 +109,8 @@
 	struct futex *newf;
 	int timeout_hz;
 	struct timeval tv = {0, 0};
-#ifdef __i386__
 	struct futex *f2;
 	int op_ret;
-#endif
 
 #ifdef	DEBUG
 	if (ldebug(sys_futex))
@@ -212,9 +208,9 @@
 		FUTEX_SYSTEM_LOCK;
 
 		/*
-		 * XXX: Linux is able cope with different addresses
+		 * XXX: Linux is able to cope with different addresses
 		 * corresponding to the same mapped memory in the sleeping
-		 * and the waker process.
+		 * and waker process(es).
 		 */
 #ifdef DEBUG
 		if (ldebug(sys_futex))
@@ -222,7 +218,7 @@
 			    td->td_proc->p_pid, args->uaddr, args->val);
 #endif
 		f = futex_get(args->uaddr, FUTEX_UNLOCKED);
-		td->td_retval[0] = futex_wake(f, args->val, NULL);
+		td->td_retval[0] = futex_wake(f, args->val, NULL, 0);
 		futex_put(f);
 
 		FUTEX_SYSTEM_UNLOCK;
@@ -244,7 +240,7 @@
 
 		f = futex_get(args->uaddr, FUTEX_UNLOCKED);
 		newf = futex_get(args->uaddr2, FUTEX_UNLOCKED);
-		td->td_retval[0] = futex_wake(f, args->val, newf);
+		td->td_retval[0] = futex_wake(f, args->val, newf, (int)(unsigned long)args->timeout);
 		futex_put(f);
 		futex_put(newf);
 
@@ -253,23 +249,23 @@
 
 	case LINUX_FUTEX_REQUEUE:
 		FUTEX_SYSTEM_LOCK;
-		
+
 		f = futex_get(args->uaddr, FUTEX_UNLOCKED);
 		newf = futex_get(args->uaddr2, FUTEX_UNLOCKED);
-		td->td_retval[0] = futex_wake(f, args->val, newf);
+		td->td_retval[0] = futex_wake(f, args->val, newf, (int)(unsigned long)args->timeout);
 		futex_put(f);
 		futex_put(newf);
-		
+
 		FUTEX_SYSTEM_UNLOCK;
 		break;
 
 	case LINUX_FUTEX_FD:
-		printf("linux_sys_futex: unimplemented op %d\n", 
+		/* XXX: linux plans to remove this operation */
+		printf("linux_sys_futex: unimplemented op %d\n",
 		    args->op);
 		break;
 
 	case LINUX_FUTEX_WAKE_OP:
-#ifdef	__i386__
 		FUTEX_SYSTEM_LOCK;
 #ifdef DEBUG
 		if (ldebug(sys_futex))
@@ -287,7 +283,7 @@
 		op_ret = futex_atomic_op(td, args->val3, args->uaddr2);
 		if (op_ret < 0) {
 
-			/* XXX: we dont handle the EFAULT yet */
+			/* XXX: We don't handle the EFAULT yet. */
 			if (op_ret != -EFAULT) {
 				futex_put(f);
 				futex_put(f2);
@@ -303,29 +299,25 @@
 
 		}
 
-		ret = futex_wake(f, args->val, NULL);
+		ret = futex_wake(f, args->val, NULL, 0);
 		futex_put(f);
 		if (op_ret > 0) {
-		   	op_ret = 0;
-		   	/*
-			 * Linux uses the address of the timespec parameter
-			 * as the number of retries, so any large number will
-			 * be ok.
+			op_ret = 0;
+			/*
+			 * Linux abuses the address of the timespec parameter
+			 * as the number of retries.
 			 */
-   		   	op_ret += futex_wake(f2, 0x7fffffff, NULL);
+			op_ret += futex_wake(f2, (int) (unsigned long) args->timeout, NULL, 0);
 			ret += op_ret;
 		}
 		futex_put(f2);
 		td->td_retval[0] = ret;
 
 		FUTEX_SYSTEM_UNLOCK;
-#else
-		printf("linux_sys_futex: wake_op not implemented");
-#endif
-	   	break;
+		break;
 
 	default:
-		printf("linux_sys_futex: unknown op %d\n", 
+		printf("linux_sys_futex: unknown op %d\n",
 		    args->op);
 		break;
 	}
@@ -414,10 +406,17 @@
 }
 
 static int
-futex_wake(struct futex *f, int n, struct futex *newf)
+futex_wake(struct futex *f, int n, struct futex *newf, int n2)
 {
 	struct waiting_proc *wp;
-	int count = 0;
+	int count;
+
+	/*
+	 * Linux is very strange it wakes up N threads for
+	 * all operations BUT requeue ones where its N+1
+	 * mimic this.
+	 */
+	count = newf ? 0 : 1;
 
 	FUTEX_LOCK;
 	TAILQ_FOREACH(wp, &f->f_waiting_proc, wp_list) {
@@ -429,6 +428,8 @@
 				/* futex_put called after tsleep */
 				wp->wp_new_futex = futex_get(newf->f_uaddr, FUTEX_LOCKED);
 				wakeup_one(wp);
+				if (count - n >= n2)
+					break;
 			}
 		}
 	}
@@ -437,72 +438,106 @@
 	return count;
 }
 
-#ifdef __i386__
 static int
 futex_atomic_op(struct thread *td, int encoded_op, caddr_t uaddr)
 {
-   	int op = (encoded_op >> 28) & 7;
-        int cmp = (encoded_op >> 24) & 15;
-        int oparg = (encoded_op << 8) >> 20;
-        int cmparg = (encoded_op << 20) >> 20;
-        int oldval = 0, ret;
+	int op = (encoded_op >> 28) & 7;
+	int cmp = (encoded_op >> 24) & 15;
+	int oparg = (encoded_op << 8) >> 20;
+	int cmparg = (encoded_op << 20) >> 20;
+	int oldval = 0, ret;
 
 	if (encoded_op & (FUTEX_OP_OPARG_SHIFT << 28))
-	   	oparg = 1 << oparg;
+		oparg = 1 << oparg;
 
-#ifdef DEBUG	
+#ifdef DEBUG
 	printf("futex_atomic_op: op = %d, cmp = %d, oparg = %d, cmparg = %d, uaddr = %p\n",
-	      op, cmp, oparg, cmparg, uaddr);
+	    op, cmp, oparg, cmparg, uaddr);
 #endif
 	/* XXX: linux verifies access here and returns EFAULT */
 
-	critical_enter();
+	switch (op) {
+	case FUTEX_OP_SET:
+		ret = futex_xchgl(oparg, uaddr, &oldval);
+		break;
+	case FUTEX_OP_ADD:
+		ret = futex_addl(oparg, uaddr, &oldval);
+		break;
+	case FUTEX_OP_OR:
+		ret = futex_orl(oparg, uaddr, &oldval);
+		break;
+	case FUTEX_OP_ANDN:
+		ret = futex_andl(~oparg, uaddr, &oldval);
+		break;
+	case FUTEX_OP_XOR:
+		ret = futex_xorl(oparg, uaddr, &oldval);
+		break;
+	default:
+		ret = -ENOSYS;
+	}
 
-	switch (op) {
-	   	case FUTEX_OP_SET:
-		   	ret = futex_xchgl(oparg, uaddr, &oldval);
+	if (!ret)
+		switch (cmp) {
+		case FUTEX_OP_CMP_EQ:
+			ret = (oldval == cmparg);
+			break;
+		case FUTEX_OP_CMP_NE:
+			ret = (oldval != cmparg);
 			break;
-		case FUTEX_OP_ADD:
-			ret = futex_addl(oparg, uaddr, &oldval);
+		case FUTEX_OP_CMP_LT:
+			ret = (oldval < cmparg);
 			break;
-		case FUTEX_OP_OR:
-			ret = futex_orl(oparg, uaddr, &oldval);
+		case FUTEX_OP_CMP_GE:
+			ret = (oldval >= cmparg);
 			break;
-		case FUTEX_OP_ANDN:
-			ret = futex_andnl(oparg, uaddr, &oldval);
+		case FUTEX_OP_CMP_LE:
+			ret = (oldval <= cmparg);
 			break;
-		case FUTEX_OP_XOR:
-			ret = futex_xorl(oparg, uaddr, &oldval);
+		case FUTEX_OP_CMP_GT:
+			ret = (oldval > cmparg);
 			break;
 		default:
 			ret = -ENOSYS;
+		}
+
+	return (ret);
+}
+
+static int
+futex_orl(int oparg, caddr_t uaddr, int *oldval)
+{
+	uint32_t ua, ua_old;
+
+	for (;;) {
+		ua = ua_old = fuword32(uaddr);
+		ua |= oparg;
+		if (casuword32((void *)uaddr, ua_old, ua) == ua_old)
+			return ua_old;
 	}
+}
 
-	critical_exit();
+static int
+futex_andl(int oparg, caddr_t uaddr, int *oldval)
+{
+	uint32_t ua, ua_old;
+
+	for (;;) {
+		ua = ua_old = fuword32(uaddr);
+		ua &= oparg;
+		if (casuword32((void *)uaddr, ua_old, ua) == ua_old)
+			return ua_old;
+	}
+}
 
-	if (!ret)
-	   	switch (cmp) {
-		      case FUTEX_OP_CMP_EQ: 
-			 	ret = (oldval == cmparg); 
-				break;
-		      case FUTEX_OP_CMP_NE: 
-				ret = (oldval != cmparg); 
-				break;
-		      case FUTEX_OP_CMP_LT: 
-				ret = (oldval < cmparg); 
-				break;
-		      case FUTEX_OP_CMP_GE: 
-				ret = (oldval >= cmparg); 
-				break;
-		      case FUTEX_OP_CMP_LE: 
-				ret = (oldval <= cmparg); 
-				break;
-		      case FUTEX_OP_CMP_GT: 
-				ret = (oldval > cmparg); 
-				break;
-		      default: ret = -ENOSYS;
-		}
+static int
+futex_xorl(int oparg, caddr_t uaddr, int *oldval)
+{
+	uint32_t ua, ua_old;
 
-	return (ret);
+	for (;;) {
+		ua = ua_old = fuword32(uaddr);
+		ua ^= oparg;
+		if (casuword32((void *)uaddr, ua_old, ua) == ua_old)
+			return ua_old;
+	}
 }
-#endif
--- sys/compat/linux/linux_misc.c.orig
+++ sys/compat/linux/linux_misc.c
@@ -52,8 +52,10 @@
 #include <sys/proc.h>
 #include <sys/reboot.h>
 #include <sys/resourcevar.h>
+#include <sys/rwlock.h>
 #include <sys/sched.h>
 #include <sys/signalvar.h>
+#include <sys/smp.h>
 #include <sys/stat.h>
 #include <sys/syscallsubr.h>
 #include <sys/sysctl.h>
@@ -219,7 +221,9 @@
 }
 
 #if defined(__i386__)
-/* XXX: what about amd64/linux32? */
+/* XXX: this syscall is used mainly by a.out binaries (which dont exist
+ * on amd64/linux32) or libc5
+ */
 
 int
 linux_uselib(struct thread *td, struct linux_uselib_args *args)
@@ -588,6 +592,18 @@
 		    (unsigned long)args->new_len,
 		    (unsigned long)args->flags);
 #endif
+
+	if (args->flags & ~(LINUX_MREMAP_FIXED | LINUX_MREMAP_MAYMOVE)) {
+		td->td_retval[0] = 0;
+		return (EINVAL);
+	}
+
+	/* Linux defines PAGE_MASK to be FreeBSD ~PAGE_MASK */
+	if (args->addr & PAGE_MASK) {
+		td->td_retval[0] = 0;
+		return (EINVAL);
+	}
+
 	args->new_len = round_page(args->new_len);
 	args->old_len = round_page(args->old_len);
 
@@ -748,7 +764,7 @@
 	return (copyout(&utsname, args->buf, sizeof(utsname)));
 }
 
-#if defined(__i386__) || (defined(__amd64__) && defined(COMPAT_LINUX32))
+#if defined(__i386__) || defined(__amd64__)
 struct l_utimbuf {
 	l_time_t l_actime;
 	l_time_t l_modtime;
@@ -818,7 +834,7 @@
 	LFREEPATH(fname);
 	return (error);
 }
-#endif /* __i386__ || (__amd64__ && COMPAT_LINUX32) */
+#endif /* __i386__ || __amd64__ */
 
 #define __WCLONE 0x80000000
 
@@ -1169,6 +1185,13 @@
 	if (error)
 		return (error);
 
+	/*
+	 * the 1024*1024 is a hardcoded constant of max files per proc in
+	 * linux
+	 */
+	if (which == RLIMIT_NOFILE && rlim.rlim_max > (1024 * 1024))
+		return (EPERM);
+
 	bsd_rlim.rlim_cur = (rlim_t)rlim.rlim_cur;
 	bsd_rlim.rlim_max = (rlim_t)rlim.rlim_max;
 	return (kern_setrlimit(td, which, &bsd_rlim));
@@ -1486,14 +1509,15 @@
 	/* find the group leader */
 	p = pfind(em->shared->group_pid);
 
+	/* lets pretend we were reparented to init */
 	if (p == NULL) {
 #ifdef DEBUG
-	   	printf(LMSG("parent process not found.\n"));
+		printf("getppid: thread group leader not found.\n");
 #endif
+		td->td_retval[0] = 1;
 		return (0);
 	}
-
-	pp = p->p_pptr;		/* switch to parent */
+	pp = p->p_pptr;			/* switch to parent */
 	PROC_LOCK(pp);
 	PROC_UNLOCK(p);
 
@@ -1711,3 +1735,28 @@
 
 	return (error);
 }
+
+int
+linux_sched_getaffinity(struct thread *td,
+    struct linux_sched_getaffinity_args *args)
+{
+	l_ulong		mask;
+	int		i;
+
+	if (PTRIN(args->mask) == NULL)
+		return (EFAULT);
+	if (args->cpusetsize < (l_uint)sizeof(cpumask_t))
+		return (EINVAL);
+
+	/* We do not support process affinity yet. Just allow all for now. */
+	for (i = mp_ncpus, mask = 0; i > 0; i--)
+		mask |= 1 << (i - 1);
+
+	return (copyout(&mask, args->mask, sizeof(l_ulong)));
+}
+
+int
+linux_chroot(struct thread *td, struct linux_chroot_args *args)
+{
+	return (chroot(td, (struct chroot_args *)args));
+}
--- sys/compat/linux/linux_misc.h.orig
+++ sys/compat/linux/linux_misc.h
@@ -42,4 +42,7 @@
 
 #define	LINUX_MAX_COMM_LEN	16	/* Maximum length of the process name. */
 
+#define	LINUX_MREMAP_MAYMOVE	1
+#define	LINUX_MREMAP_FIXED	2
+
 #endif	/* _LINUX_MISC_H_ */
--- sys/compat/linux/linux_socket.c.orig
+++ sys/compat/linux/linux_socket.c
@@ -35,6 +35,7 @@
 
 #include <sys/param.h>
 #include <sys/proc.h>
+#include <sys/syslog.h>
 #include <sys/systm.h>
 #include <sys/sysproto.h>
 #include <sys/fcntl.h>
@@ -1026,6 +1027,15 @@
 	if (error)
 		return (error);
 	error = copyin(PTRIN(linux_args.msg), &msg, sizeof(msg));
+
+	/* 
+	 * Ping on linux does pass 0 in controllen which is forbidden
+	 * by FreeBSD but seems to be ok on Linux. This needs some
+	 * checking but now it lets ping work.
+	 */
+	if (msg.msg_control && msg.msg_controllen == 0)
+	   	msg.msg_controllen = sizeof(struct cmsghdr);
+
 	if (error)
 		return (error);
 	error = copyiniov(msg.msg_iov, msg.msg_iovlen, &iov, EMSGSIZE);
@@ -1194,7 +1204,13 @@
 		caddr_t val;
 		int *avalsize;
 	} */ bsd_args;
-	int error, name;
+	struct linux_ucred {
+		uint32_t pid;
+		uint32_t uid;
+		uint32_t gid;
+	} linux_ucred;
+	struct xucred xuc;
+	int error, name, optlen, rc, xuclen;
 
 	if ((error = copyin(args, &linux_args, sizeof(linux_args))))
 		return (error);
@@ -1216,18 +1232,47 @@
 		name = -1;
 		break;
 	}
-	if (name == -1)
+	if (name == -1) {
+		log(LOG_WARNING, "LINUX: 'getsockopt' level=0x%04x"
+		    "optname=0x%04x not implemented\n",
+		    linux_args.level, linux_args.optname);
 		return (EINVAL);
+	};
 
 	bsd_args.name = name;
-	bsd_args.val = PTRIN(linux_args.optval);
-	bsd_args.avalsize = PTRIN(linux_args.optlen);
+	if (bsd_args.level == SOL_SOCKET && name == LOCAL_PEERCRED) {
+		if ((error = copyin(PTRIN(linux_args.optval),
+		    &linux_ucred, sizeof(linux_ucred))))
+			return (error);
+		if ((error = copyin(PTRIN(linux_args.optlen),
+		    &optlen, sizeof(optlen))))
+			return (error);
+		if (optlen < sizeof(linux_ucred))
+			return (EFAULT);
+		xuclen = sizeof(xuc);
+		if ((rc = error = kern_getsockopt(td, bsd_args.s,
+		    0, bsd_args.name,
+		    (caddr_t) &xuc, UIO_SYSSPACE, &xuclen)))
+			return (error);
+		if (xuc.cr_version != XUCRED_VERSION)
+			return (EINVAL);
+		/* XXX get PID */
+		linux_ucred.pid = 0;
+		linux_ucred.uid = xuc.cr_uid;
+		linux_ucred.gid = xuc.cr_gid;
+		if ((error = copyout(&linux_ucred,
+		    PTRIN(linux_args.optval), sizeof(linux_ucred))))
+			return (error);
+		return (rc);
+	} else {
+		bsd_args.val = PTRIN(linux_args.optval);
+		bsd_args.avalsize = PTRIN(linux_args.optlen);
+	}
+
+	error = getsockopt(td, &bsd_args);
 
-	if (name == IPV6_NEXTHOP) {
-		error = getsockopt(td, &bsd_args);
+	if (name == IPV6_NEXTHOP)
 		bsd_to_linux_sockaddr((struct sockaddr *)bsd_args.val);
-	} else
-		error = getsockopt(td, &bsd_args);
 
 	return (error);
 }
@@ -1277,3 +1322,34 @@
 	uprintf("LINUX: 'socket' typ=%d not implemented\n", args->what);
 	return (ENOSYS);
 }
+
+int
+linux_sendfile(struct thread *td, struct linux_sendfile_args *args)
+{
+	struct sendfile_args sa;
+	off_t off;
+	int error;
+
+	if ((error = copyin(args->offset, &off, sizeof(off))))
+		return (error);
+#ifdef DEBUG	
+	if (ldebug(sendfile))
+		printf(ARGS(sendfile, "%d, %d, %d, %d"), args->in, args->out, (int) off, 
+		      args->count);
+#endif
+
+	sa.fd = args->in; 
+	sa.s = args->out;
+	sa.offset = off;
+	sa.nbytes = args->count;
+	sa.hdtr = NULL;
+	sa.sbytes = NULL;
+	sa.flags = 0;
+
+	error = sendfile(td, &sa);
+	if (error)
+		return (error);
+
+	td->td_retval[0] = args->count;
+	return (0);
+}
--- sys/compat/linux/linux_stats.c.orig
+++ sys/compat/linux/linux_stats.c
@@ -461,12 +461,27 @@
 int
 linux_ustat(struct thread *td, struct linux_ustat_args *args)
 {
+        struct mount *mp;
+        struct l_ustat linux_ustat;
+
 #ifdef DEBUG
-	if (ldebug(ustat))
-		printf(ARGS(ustat, "%d, *"), args->dev);
+        if (ldebug(ustat))
+                printf(ARGS(ustat, "%d, *"), args->dev);
 #endif
+        mtx_lock(&mountlist_mtx);
+        TAILQ_FOREACH_REVERSE(mp, &mountlist, mntlist, mnt_list)
+                if (mp->mnt_stat.f_fsid.val[0] == args->dev)
+                        break;
+        mtx_unlock(&mountlist_mtx);
+
+	if (mp == NULL)
+	   	return (EINVAL);
+
+        bzero(&linux_ustat, sizeof(linux_ustat));
+        linux_ustat.f_tfree = mp->mnt_stat.f_bfree;
+        linux_ustat.f_tinode = mp->mnt_stat.f_ffree;
 
-	return (EOPNOTSUPP);
+        return copyout(&linux_ustat, args->ubuf, sizeof(linux_ustat));
 }
 
 #if defined(__i386__) || (defined(__amd64__) && defined(COMPAT_LINUX32))
--- sys/compat/linux/linux_util.h.orig
+++ sys/compat/linux/linux_util.h
@@ -53,16 +53,19 @@
 
 int linux_emul_convpath(struct thread *, char *, enum uio_seg, char **, int);
 
-#define LCONVPATH(td, upath, pathp, i) 					\
+#define LCONVPATH_SEG(td, upath, pathp, i, seg)				\
 	do {								\
 		int _error;						\
 									\
-		_error = linux_emul_convpath(td, upath, UIO_USERSPACE,  \
+		_error = linux_emul_convpath(td, upath, seg,		\
 		    pathp, i);						\
 		if (*(pathp) == NULL)					\
 			return (_error);				\
 	} while (0)
 
+#define LCONVPATH(td, upath, pathp, i) 	\
+   LCONVPATH_SEG(td, upath, pathp, i, UIO_USERSPACE)
+
 #define LCONVPATHEXIST(td, upath, pathp) LCONVPATH(td, upath, pathp, 0)
 #define LCONVPATHCREAT(td, upath, pathp) LCONVPATH(td, upath, pathp, 1)
 #define LFREEPATH(path)	free(path, M_TEMP)
--- sys/conf/files.amd64.orig
+++ sys/conf/files.amd64
@@ -233,7 +233,8 @@
 amd64/linux32/linux32_machdep.c	optional	compat_linux32
 amd64/linux32/linux32_sysent.c	optional	compat_linux32
 amd64/linux32/linux32_sysvec.c	optional	compat_linux32
-compat/linux/linux_emul.c       optional	compat_linux32
+compat/linux/linux_aio.c	optional	linuxaio compat_linux32 vfs_aio
+compat/linux/linux_emul.c	optional	compat_linux32
 compat/linux/linux_file.c	optional	compat_linux32
 compat/linux/linux_futex.c	optional	compat_linux32
 compat/linux/linux_getcwd.c	optional	compat_linux32
--- sys/conf/files.i386.orig
+++ sys/conf/files.i386
@@ -85,6 +85,7 @@
 #
 compat/linprocfs/linprocfs.c	optional linprocfs
 compat/linsysfs/linsysfs.c	optional linsysfs
+compat/linux/linux_aio.c	optional linuxaio compat_linux aio
 compat/linux/linux_emul.c	optional compat_linux
 compat/linux/linux_file.c	optional compat_linux
 compat/linux/linux_futex.c	optional compat_linux
--- sys/conf/files.pc98.orig
+++ sys/conf/files.pc98
@@ -55,6 +55,7 @@
 #
 compat/linprocfs/linprocfs.c	optional linprocfs
 compat/linsysfs/linsysfs.c	optional linsysfs
+compat/linux/linux_aio.c	optional linuxaio compat_linux vfs_aio
 compat/linux/linux_emul.c	optional compat_linux
 compat/linux/linux_file.c	optional compat_linux
 compat/linux/linux_futex.c	optional compat_linux
--- sys/conf/options.amd64.orig
+++ sys/conf/options.amd64
@@ -19,6 +19,7 @@
 #DEBUG_SVR4		opt_svr4.h
 LINPROCFS		opt_dontuse.h
 LINSYSFS		opt_dontuse.h
+LINUXAIO		opt_dontuse.h
 NDISAPI			opt_dontuse.h
 
 CLK_CALIBRATION_LOOP		opt_clock.h
--- sys/conf/options.i386.orig
+++ sys/conf/options.i386
@@ -26,6 +26,7 @@
 DEBUG_SVR4		opt_svr4.h
 LINPROCFS		opt_dontuse.h
 LINSYSFS		opt_dontuse.h
+LINUXAIO		opt_dontuse.h
 NDISAPI			opt_dontuse.h
 PECOFF_DEBUG		opt_pecoff.h
 PECOFF_SUPPORT		opt_dontuse.h
--- sys/conf/options.pc98.orig
+++ sys/conf/options.pc98
@@ -25,6 +25,7 @@
 DEBUG_SVR4		opt_svr4.h
 LINPROCFS		opt_dontuse.h
 LINSYSFS		opt_dontuse.h
+LINUXAIO		opt_dontuse.h
 PECOFF_DEBUG		opt_pecoff.h
 PECOFF_SUPPORT		opt_dontuse.h
 
--- sys/i386/conf/NOTES.orig
+++ sys/i386/conf/NOTES
@@ -1133,9 +1133,12 @@
 # and PSEUDOFS)
 options 	LINPROCFS
 
-#Enable the linux-like sys filesystem support (requires COMPAT_LINUX
+# Enable the linux-like sys filesystem support (requires COMPAT_LINUX
 # and PSEUDOFS)
-options		LINSYSFS
+options 	LINSYSFS
+
+# Enable the linux aio support (requires COMPAT_LINUX and VFS_AIO)
+options 	LINUXAIO
 
 #
 # SysVR4 ABI emulation
--- sys/i386/i386/support.s.orig
+++ sys/i386/i386/support.s
@@ -1549,8 +1549,7 @@
 	ret
 
 /* int futex_xchgl(int oparg, caddr_t uaddr, int *oldval); */
-	.globl	futex_xchgl
-futex_xchgl:
+ENTRY(futex_xchgl)
 	movl	PCPU(CURPCB), %eax
 	movl	$futex_fault, PCB_ONFAULT(%eax)
 	movl	4(%esp), %eax
@@ -1568,8 +1567,7 @@
 	ret
 
 /* int futex_addl(int oparg, caddr_t uaddr, int *oldval); */
-	.globl	futex_addl
-futex_addl:
+ENTRY(futex_addl)
 	movl	PCPU(CURPCB), %eax
 	movl	$futex_fault, PCB_ONFAULT(%eax)
 	movl	4(%esp), %eax
@@ -1586,60 +1584,3 @@
 	movl	$0, PCB_ONFAULT(%edx)
 	ret
 
-/* int futex_orl(int oparg, caddr_t uaddr, int *oldval); */
-	.globl	futex_orl
-futex_orl:
-	movl	PCPU(CURPCB), %eax
-	movl	$futex_fault, PCB_ONFAULT(%eax)
-	movl	4(%esp), %eax
-	movl	8(%esp), %edx
-	cmpl    $VM_MAXUSER_ADDRESS,%edx
-	ja     	futex_fault
-
-	MPLOCKED orl 	%eax, (%edx)
-	movl	0xc(%esp), %edx
-	movl	%eax, (%edx)
-	xorl	%eax, %eax
-
-	movl	PCPU(CURPCB), %edx
-	movl	$0, PCB_ONFAULT(%edx)
-	ret
-
-/* int futex_andnl(int oparg, caddr_t uaddr, int *oldval); */
-	.globl	futex_andnl
-futex_andnl:
-	movl	PCPU(CURPCB), %eax
-	movl	$futex_fault, PCB_ONFAULT(%eax)
-	movl	4(%esp), %eax
-	movl	8(%esp), %edx
-	cmpl    $VM_MAXUSER_ADDRESS,%edx
-	ja     	futex_fault
-
-	notl	(%edx)
-	MPLOCKED andl 	%eax, (%edx)
-	movl	0xc(%esp), %edx
-	movl	%eax, (%edx)
-	xorl	%eax, %eax
-
-	movl	PCPU(CURPCB), %edx
-	movl	$0, PCB_ONFAULT(%edx)
-	ret
-
-/* int futex_xorl(int oparg, caddr_t uaddr, int *oldval); */
-	.globl	futex_xorl
-futex_xorl:
-	movl	PCPU(CURPCB), %eax
-	movl	$futex_fault, PCB_ONFAULT(%eax)
-	movl	4(%esp), %eax
-	movl	8(%esp), %edx
-	cmpl    $VM_MAXUSER_ADDRESS,%edx
-	ja     	futex_fault
-
-	MPLOCKED xorl 	%eax, (%edx)
-	movl	0xc(%esp), %edx
-	movl	%eax, (%edx)
-	xorl	%eax, %eax
-
-	movl	PCPU(CURPCB), %edx
-	movl	$0, PCB_ONFAULT(%edx)
-	ret
--- sys/i386/linux/linux.h.orig
+++ sys/i386/linux/linux.h
@@ -502,6 +502,7 @@
 #define	LINUX_O_RDONLY		00000000
 #define	LINUX_O_WRONLY		00000001
 #define	LINUX_O_RDWR		00000002
+#define	LINUX_O_ACCMODE		00000003
 #define	LINUX_O_CREAT		00000100
 #define	LINUX_O_EXCL		00000200
 #define	LINUX_O_NOCTTY		00000400
@@ -536,6 +537,8 @@
 #define	LINUX_F_WRLCK		1
 #define	LINUX_F_UNLCK		2
 
+#define	LINUX_AT_FDCWD		-100
+
 /*
  * mount flags
  */
@@ -831,4 +834,6 @@
 	(LINUX_CLONE_VM | LINUX_CLONE_FS | LINUX_CLONE_FILES |	\
 	LINUX_CLONE_SIGHAND | LINUX_CLONE_THREAD)
 
+#include <compat/linux/linux_aio.h>
+
 #endif /* !_I386_LINUX_H_ */
--- sys/i386/linux/linux_dummy.c.orig
+++ sys/i386/linux/linux_dummy.c
@@ -59,7 +59,6 @@
 DUMMY(rt_sigqueueinfo);
 DUMMY(capget);
 DUMMY(capset);
-DUMMY(sendfile);		/* different semantics */
 DUMMY(truncate64);
 DUMMY(setfsuid);
 DUMMY(setfsgid);
@@ -87,7 +86,6 @@
 DUMMY(inotify_add_watch);
 DUMMY(inotify_rm_watch);
 DUMMY(migrate_pages);
-DUMMY(openat);
 DUMMY(mkdirat);
 DUMMY(mknodat);
 DUMMY(fchownat);
@@ -103,6 +101,11 @@
 DUMMY(pselect6);
 DUMMY(ppoll);
 DUMMY(unshare);
+DUMMY(io_setup);
+DUMMY(io_destroy);
+DUMMY(io_getevents);
+DUMMY(io_submit);
+DUMMY(io_cancel);
 
 #define DUMMY_XATTR(s)						\
 int								\
